<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form id="formId" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托单位:">
                <Input v-model="formObj.client" @on-enter="_formSearch" name="client" placeholder="请输入委托单位" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                      class="contHide"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange" hide-checkbox>
              <vxe-table-column
                      v-for="item in pageColumns"
                      :key="item.key"
                      :field="item.key"
                      :title="item.title"
                      :min-width="item.width?item.width:200"
                      :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <FileManage ref="FileManage"></FileManage>
    <MeterSampleQuoteManage ref="meterSampleQuoteManageModal" @on-result-change="_formSearch"></MeterSampleQuoteManage>
    <MeterContractRecord ref="meterContractRecordModal" @on-result-change="_formSearch"></MeterContractRecord>
  </div>
</template>
<script>
import MeterSampleQuoteManage from '../MeterSampleQuoteManage'
import MeterContractRecord from '../MeterContractRecord'
import { meterContract, meterSubcontractor } from '../../../api'
export default {
  components: { MeterSampleQuoteManage, MeterContractRecord },
  data() {
    return {
      currentComponent: '',
      formId: 'meterSubcontractorFormId',
      searchOpen: true,
      btn: [],
      iconMsg: [
        {
          type: 'ios-beaker',
          id: 'meter-contract-accepted-his-check-sample-query-o',
          name: '报检样品查询'
        },
        {
          type: 'ios-cloud',
          id: 'meter-contract-accepted-his-accessory-o',
          name: '附件'
        },
        {
          type: 'ios-clock',
          id: 'meter-contract-accepted-his-record-o',
          name: '操作日志'
        }
      ],
      formObj: {
        client: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '委托单位', key: 'client', width: 200 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '传真', key: 'fax', width: 120 },
        { title: '要求完成时间', key: 'odate', width: 120, date: true },
        { title: '折扣', key: 'discount', width: 120 },
        { title: '总价', key: 'totalPrice', width: 120 },
        { title: '折扣价', key: 'discountPrice', width: 120 },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '添加':
            this._editModal(false)
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '编辑':
            this._editModal(true, data.id)
            break
          case '报检样品查询':
            this._itemModal(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _record(id) {
      this.$refs.meterContractRecordModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await meterContract.pageAcceptedHis(this.formObj)
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        // this.$refs.editSubcontractorModal._open(id)
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },
    _itemModal(data) {
      this.$refs.meterSampleQuoteManageModal._open(data)
    },
    _upload(id) {
      // 上传文件
      // this.$refs.refModal._open(id, 'subcontractorId')
      this.$refs.FileManage._open(id, 'subcontractorId')
    },
    _getById: async function(id) {
      const result = await meterSubcontractor.getById(id)
      if (result) {
        this.$refs.editSubcontractorModal._open(result)
      }
    }
  }
}
</script>
